var request = require('request'),
    url = require('url');

var drnu = {};

var apiUrlPrefix = "http://www.dr.dk/nu/api/"

drnu.getProgramSeries = function(callback) {
    fetch("programseries", callback);
};

drnu.getProgramSerieImageUrl = function(programSerieSlug, options) {
    ///api/programseries/{programSerieSlug}/images/{width}x{height}.jpg
    return url.parse(apiUrlPrefix + "programseries/" + programSerieSlug + "/images/" + options.width + "x" + options.height + ".jpg");
};

drnu.getProgramSerieVideos = function(programSerieSlug, callback) {
    ///api/programseries/{programSerieSlug}/videos
    fetch("programseries/" + programSerieSlug + "/videos", callback)
}

/**
 *
 * @param filter can be all, newest, spot, mostviewed
 * @param callback
 */
drnu.getVideos = function(filter, callback) {
    fetch("videos/" + filter, callback)
}

drnu.getVideo = function(videoId, callback) {
    fetch("videos/" + videoId, callback);
}

drnu.getVideoImageUrl = function(videoId, options) {
    //api/videos/{videoId}/images/{width}x{height}.jpg
    return url.parse(apiUrlPrefix + "videos/" + videoId + "images" + options.width + "x" + options.height + ".jpg");
}

drnu.getChapterImageUrl = function(chapterId, options) {
    //api/chapters/{chapterId}/images/{width}x{height}.jpg
    return url.parse(apiUrlPrefix + "chapters/" + chapterId + "images" + options.width + "x" + options.height + ".jpg");
}

drnu.search = function(term, callback) {
    fetch("search/" + term, callback);
}

fetch = function(apiFunction, callback) {
    uri = apiUrlPrefix + apiFunction + ".json"

    request({uri: uri}, function(error, response, body) {
        callback(error, JSON.parse(body));
    });
}

module.exports = drnu;